#include <stdio.h>
#include "vnkeys.h"
#include "ctype.h"
#include "vn78.h"


static _doinit() { /* fill the map--the code is independent of the encoding */
    /* C0 ASCII section---must be first to be overridden by Vietnamese */
    _8to7map[C_SOH][0] = C_SOH;
    _8to7map[C_STX][0] = C_STX;
    _8to7map[C_ETX][0] = C_ETX;
    _8to7map[C_EOT][0] = C_EOT;
    _8to7map[C_ENQ][0] = C_ENQ;
    _8to7map[C_ACK][0] = C_ACK;
    _8to7map[C_BEL][0] = C_BEL;
    _8to7map[C_BS][0] = C_BS;
    _8to7map[C_HT][0] = C_HT;
    _8to7map[C_LF][0] = C_LF;
    _8to7map[C_VT][0] = C_VT;
    _8to7map[C_FF][0] = C_FF;
    _8to7map[C_CR][0] = C_CR;
    _8to7map[C_SO][0] = C_SO;
    _8to7map[C_SI][0] = C_SI;
    _8to7map[C_DLE][0] = C_DLE;
    _8to7map[C_DC1][0] = C_DC1;
    _8to7map[C_DC2][0] = C_DC2;
    _8to7map[C_DC3][0] = C_DC3;
    _8to7map[C_DC4][0] = C_DC4;
    _8to7map[C_NAK][0] = C_NAK;
    _8to7map[C_SYN][0] = C_SYN;
    _8to7map[C_ETB][0] = C_ETB;
    _8to7map[C_CAN][0] = C_CAN;
    _8to7map[C_EM][0] = C_EM;
    _8to7map[C_SUB][0] = C_SUB;
    _8to7map[C_ESC][0] = C_ESC;
    _8to7map[C_IS4][0] = C_IS4;
    _8to7map[C_IS3][0] = C_IS3;
    _8to7map[C_IS2][0] = C_IS2;
    _8to7map[C_IS1][0] = C_IS1;

    /* C0 Vietnamese section */
    _8to7map[C_A_breve_hook_above][0] = C_A;
    _8to7map[C_A_breve_hook_above][1] = C_breve;
    _8to7map[C_A_breve_hook_above][2] = C_hook_above;
    _8to7map[C_A_breve_tilde][0] = C_A;
    _8to7map[C_A_breve_tilde][1] = C_breve;
    _8to7map[C_A_breve_tilde][2] = C_tilde;
    _8to7map[C_A_circumflex_tilde][0] = C_A;
    _8to7map[C_A_circumflex_tilde][1] = C_caret;
    _8to7map[C_A_circumflex_tilde][2] = C_tilde;
    _8to7map[C_Y_hook_above][0] = C_Y;
    _8to7map[C_Y_hook_above][1] = C_hook_above;
    _8to7map[C_y_hook_above/C_IS3][0] = C_y;
    _8to7map[C_y_hook_above/C_IS3][1] = C_hook_above;
    _8to7map[C_Y_tilde][0] = C_Y;
    _8to7map[C_Y_tilde][1] = C_tilde;
    _8to7map[C_Y_dot_below][0] = C_Y;
    _8to7map[C_Y_dot_below][1] = C_dot_below;

    _8to7map[C_space][0] = C_space;
    _8to7map[C_exclamation_mark][0] = C_exclamation_mark;
    _8to7map[C_quotation_mark][0] = C_quotation_mark;
    _8to7map[C_pound_sign][0] = C_pound_sign;
    _8to7map[C_dollar_sign][0] = C_dollar_sign;
    _8to7map[C_percent][0] = C_percent;
    _8to7map[C_ampersand][0] = C_ampersand;
    _8to7map[C_apostrophe][0] = C_apostrophe;
    _8to7map[C_left_parenthesis][0] = C_left_parenthesis;
    _8to7map[C_right_parenthesis][0] = C_right_parenthesis;
    _8to7map[C_asterisk][0] = C_asterisk;
    _8to7map[C_plus_sign][0] = C_plus_sign;
    _8to7map[C_comma][0] = C_comma;
    _8to7map[C_hyphen][0] = C_hyphen;
    _8to7map[C_period][0] = C_period;
    _8to7map[C_slash][0] = C_slash;

    _8to7map[C_zero][0] = C_zero;
    _8to7map[C_one][0] = C_one;
    _8to7map[C_two][0] = C_two;
    _8to7map[C_three][0] = C_three;
    _8to7map[C_four][0] = C_four;
    _8to7map[C_five][0] = C_five;
    _8to7map[C_six][0] = C_six;
    _8to7map[C_seven][0] = C_seven;
    _8to7map[C_eight][0] = C_eight;
    _8to7map[C_nine][0] = C_nine;

    _8to7map[C_colon][0] = C_colon;
    _8to7map[C_semicolon][0] = C_semicolon;
    _8to7map[C_less_than][0] = C_less_than;
    _8to7map[C_equals_sign][0] = C_equals_sign;
    _8to7map[C_greater_than][0] = C_greater_than;
    _8to7map[C_hook_above][0] = C_hook_above;
    _8to7map[C_commercial_at][0] = C_commercial_at;

    _8to7map[C_A][0] = C_A;
    _8to7map[C_B][0] = C_B;
    _8to7map[C_C][0] = C_C;
    _8to7map[C_D][0] = C_D;
    _8to7map[C_E][0] = C_E;
    _8to7map[C_F][0] = C_F;
    _8to7map[C_G][0] = C_G;
    _8to7map[C_H][0] = C_H;
    _8to7map[C_I][0] = C_I;
    _8to7map[C_J][0] = C_J;
    _8to7map[C_K][0] = C_K;
    _8to7map[C_L][0] = C_L;
    _8to7map[C_M][0] = C_M;
    _8to7map[C_N][0] = C_N;
    _8to7map[C_O][0] = C_O;
    _8to7map[C_P][0] = C_P;
    _8to7map[C_Q][0] = C_Q;
    _8to7map[C_R][0] = C_R;
    _8to7map[C_S][0] = C_S;
    _8to7map[C_T][0] = C_T;
    _8to7map[C_U][0] = C_U;
    _8to7map[C_V][0] = C_V;
    _8to7map[C_W][0] = C_W;
    _8to7map[C_X][0] = C_X;
    _8to7map[C_Y][0] = C_Y;
    _8to7map[C_Z][0] = C_Z;

    _8to7map[C_left_square_bracket][0] = C_left_square_bracket;
    _8to7map[C_back_slash][0] = C_back_slash;
    _8to7map[C_right_square_bracket][0] = C_right_square_bracket;
    _8to7map[C_caret][0] = C_caret;
    _8to7map[C_underscore][0] = C_underscore;
    _8to7map[C_backquote][0] = C_backquote;

    _8to7map[C_a][0] = C_a;
    _8to7map[C_b][0] = C_b;
    _8to7map[C_c][0] = C_c;
    _8to7map[C_d][0] = C_d;
    _8to7map[C_e][0] = C_e;
    _8to7map[C_f][0] = C_f;
    _8to7map[C_g][0] = C_g;
    _8to7map[C_h][0] = C_h;
    _8to7map[C_i][0] = C_i;
    _8to7map[C_j][0] = C_j;
    _8to7map[C_k][0] = C_k;
    _8to7map[C_l][0] = C_l;
    _8to7map[C_m][0] = C_m;
    _8to7map[C_n][0] = C_n;
    _8to7map[C_o][0] = C_o;
    _8to7map[C_p][0] = C_p;
    _8to7map[C_q][0] = C_q;
    _8to7map[C_r][0] = C_r;
    _8to7map[C_s][0] = C_s;
    _8to7map[C_t][0] = C_t;
    _8to7map[C_u][0] = C_u;
    _8to7map[C_v][0] = C_v;
    _8to7map[C_w][0] = C_w;
    _8to7map[C_x][0] = C_x;
    _8to7map[C_y][0] = C_y;
    _8to7map[C_z][0] = C_z;

    _8to7map[C_left_brace][0] = C_left_brace;
    _8to7map[C_vertical_bar][0] = C_vertical_bar;
    _8to7map[C_right_brace][0] = C_right_brace;
    _8to7map[C_tilde][0] = C_tilde;
    _8to7map[C_delete][0] = C_delete;

    /* C1 & G1 Vietnamese section */
    _8to7map[C_A_hook_above][0] = C_A;
    _8to7map[C_A_hook_above][1] = C_hook_above;
    _8to7map[C_A_dot_below][0] = C_A;
    _8to7map[C_A_dot_below][1] = C_dot_below;
    _8to7map[C_A_breve][0] = C_A;
    _8to7map[C_A_breve][1] = C_breve;
    _8to7map[C_A_breve_acute][0] = C_A;
    _8to7map[C_A_breve_acute][1] = C_breve;
    _8to7map[C_A_breve_acute][2] = C_acute;
    _8to7map[C_A_breve_grave][0] = C_A;
    _8to7map[C_A_breve_grave][1] = C_breve;
    _8to7map[C_A_breve_grave][2] = C_grave;
    _8to7map[C_A_breve_dot_below][0] = C_A;
    _8to7map[C_A_breve_dot_below][1] = C_breve;
    _8to7map[C_A_breve_dot_below][2] = C_dot_below;
    _8to7map[C_A_circumflex_acute][0] = C_A;
    _8to7map[C_A_circumflex_acute][1] = C_circumflex;
    _8to7map[C_A_circumflex_acute][2] = C_acute;
    _8to7map[C_A_circumflex_grave][0] = C_A;
    _8to7map[C_A_circumflex_grave][1] = C_circumflex;
    _8to7map[C_A_circumflex_grave][2] = C_grave;
    _8to7map[C_A_circumflex_hook_above][0] = C_A;
    _8to7map[C_A_circumflex_hook_above][1] = C_circumflex;
    _8to7map[C_A_circumflex_hook_above][2] = C_hook_above;
    _8to7map[C_A_circumflex_dot_below][0] = C_A;
    _8to7map[C_A_circumflex_dot_below][1] = C_circumflex;
    _8to7map[C_A_circumflex_dot_below][2] = C_dot_below;
    _8to7map[C_E_hook_above][0] = C_E;
    _8to7map[C_E_hook_above][1] = C_hook_above;
    _8to7map[C_E_tilde][0] = C_E;
    _8to7map[C_E_tilde][1] = C_tilde;
    _8to7map[C_E_dot_below][0] = C_E;
    _8to7map[C_E_dot_below][1] = C_dot_below;
    _8to7map[C_E_circumflex_acute][0] = C_E;
    _8to7map[C_E_circumflex_acute][1] = C_circumflex;
    _8to7map[C_E_circumflex_acute][2] = C_acute;
    _8to7map[C_E_circumflex_grave][0] = C_E;
    _8to7map[C_E_circumflex_grave][1] = C_circumflex;
    _8to7map[C_E_circumflex_grave][2] = C_grave;
    _8to7map[C_E_circumflex_hook_above][0] = C_E;
    _8to7map[C_E_circumflex_hook_above][1] = C_circumflex;
    _8to7map[C_E_circumflex_hook_above][2] = C_hook_above;
    _8to7map[C_E_circumflex_tilde][0] = C_E;
    _8to7map[C_E_circumflex_tilde][1] = C_circumflex;
    _8to7map[C_E_circumflex_tilde][2] = C_tilde;
    _8to7map[C_E_circumflex_dot_below][0] = C_E;
    _8to7map[C_E_circumflex_dot_below][1] = C_circumflex;
    _8to7map[C_E_circumflex_dot_below][2] = C_dot_below;
    _8to7map[C_I_hook_above][0] = C_I;
    _8to7map[C_I_hook_above][1] = C_hook_above;
    _8to7map[C_I_tilde][0] = C_I;
    _8to7map[C_I_tilde][1] = C_tilde;
    _8to7map[C_I_dot_below][0] = C_I;
    _8to7map[C_I_dot_below][1] = C_dot_below;
    _8to7map[C_O_hook_above][0] = C_O;
    _8to7map[C_O_hook_above][1] = C_hook_above;
    _8to7map[C_O_dot_below][0] = C_O;
    _8to7map[C_O_dot_below][1] = C_dot_below;
    _8to7map[C_O_circumflex_acute][0] = C_O;
    _8to7map[C_O_circumflex_acute][1] = C_circumflex;
    _8to7map[C_O_circumflex_acute][2] = C_acute;
    _8to7map[C_O_circumflex_grave][0] = C_O;
    _8to7map[C_O_circumflex_grave][1] = C_circumflex;
    _8to7map[C_O_circumflex_grave][2] = C_grave;
    _8to7map[C_O_circumflex_hook_above][0] = C_O;
    _8to7map[C_O_circumflex_hook_above][1] = C_circumflex;
    _8to7map[C_O_circumflex_hook_above][2] = C_hook_above;
    _8to7map[C_O_circumflex_tilde][0] = C_O;
    _8to7map[C_O_circumflex_tilde][1] = C_circumflex;
    _8to7map[C_O_circumflex_tilde][2] = C_tilde;
    _8to7map[C_O_circumflex_dot_below][0] = C_O;
    _8to7map[C_O_circumflex_dot_below][1] = C_circumflex;
    _8to7map[C_O_circumflex_dot_below][2] = C_dot_below;
    _8to7map[C_O_horn][0] = C_O;
    _8to7map[C_O_horn][1] = C_horn;
    _8to7map[C_O_horn_acute][0] = C_O;
    _8to7map[C_O_horn_acute][1] = C_horn;
    _8to7map[C_O_horn_acute][2] = C_acute;
    _8to7map[C_O_horn_grave][0] = C_O;
    _8to7map[C_O_horn_grave][1] = C_horn;
    _8to7map[C_O_horn_grave][2] = C_grave;
    _8to7map[C_O_horn_hook_above][0] = C_O;
    _8to7map[C_O_horn_hook_above][1] = C_horn;
    _8to7map[C_O_horn_hook_above][2] = C_hook_above;

    _8to7map[C_a_hook_above][0] = C_a;
    _8to7map[C_a_hook_above][1] = C_hook_above;
    _8to7map[C_a_dot_below][0] = C_a;
    _8to7map[C_a_dot_below][1] = C_dot_below;
    _8to7map[C_a_breve][0] = C_a;
    _8to7map[C_a_breve][1] = C_breve;
    _8to7map[C_a_breve_acute][0] = C_a;
    _8to7map[C_a_breve_acute][1] = C_breve;
    _8to7map[C_a_breve_acute][2] = C_acute;
    _8to7map[C_a_breve_grave][0] = C_a;
    _8to7map[C_a_breve_grave][1] = C_breve;
    _8to7map[C_a_breve_grave][2] = C_grave;
    _8to7map[C_a_breve_dot_below][0] = C_a;
    _8to7map[C_a_breve_dot_below][1] = C_breve;
    _8to7map[C_a_breve_dot_below][2] = C_dot_below;
    _8to7map[C_a_circumflex_acute][0] = C_a;
    _8to7map[C_a_circumflex_acute][1] = C_circumflex;
    _8to7map[C_a_circumflex_acute][2] = C_acute;
    _8to7map[C_a_circumflex_grave][0] = C_a;
    _8to7map[C_a_circumflex_grave][1] = C_circumflex;
    _8to7map[C_a_circumflex_grave][2] = C_grave;
    _8to7map[C_a_circumflex_hook_above][0] = C_a;
    _8to7map[C_a_circumflex_hook_above][1] = C_circumflex;
    _8to7map[C_a_circumflex_hook_above][2] = C_hook_above;
    _8to7map[C_a_circumflex_dot_below][0] = C_a;
    _8to7map[C_a_circumflex_dot_below][1] = C_circumflex;
    _8to7map[C_a_circumflex_dot_below][2] = C_dot_below;
    _8to7map[C_e_hook_above][0] = C_e;
    _8to7map[C_e_hook_above][1] = C_hook_above;
    _8to7map[C_e_tilde][0] = C_e;
    _8to7map[C_e_tilde][1] = C_tilde;
    _8to7map[C_e_dot_below][0] = C_e;
    _8to7map[C_e_dot_below][1] = C_dot_below;
    _8to7map[C_e_circumflex_acute][0] = C_e;
    _8to7map[C_e_circumflex_acute][1] = C_circumflex;
    _8to7map[C_e_circumflex_acute][2] = C_acute;
    _8to7map[C_e_circumflex_grave][0] = C_e;
    _8to7map[C_e_circumflex_grave][1] = C_circumflex;
    _8to7map[C_e_circumflex_grave][2] = C_grave;
    _8to7map[C_e_circumflex_hook_above][0] = C_e;
    _8to7map[C_e_circumflex_hook_above][1] = C_circumflex;
    _8to7map[C_e_circumflex_hook_above][2] = C_hook_above;
    _8to7map[C_e_circumflex_tilde][0] = C_e;
    _8to7map[C_e_circumflex_tilde][1] = C_circumflex;
    _8to7map[C_e_circumflex_tilde][2] = C_tilde;
    _8to7map[C_e_circumflex_dot_below][0] = C_e;
    _8to7map[C_e_circumflex_dot_below][1] = C_circumflex;
    _8to7map[C_e_circumflex_dot_below][2] = C_dot_below;
    _8to7map[C_i_hook_above][0] = C_i;
    _8to7map[C_i_hook_above][1] = C_hook_above;
    _8to7map[C_U_horn_tilde][0] = C_U;
    _8to7map[C_U_horn_tilde][1] = C_horn;
    _8to7map[C_U_horn_tilde][2] = C_tilde;
    _8to7map[C_U_horn_dot_below][0] = C_U;
    _8to7map[C_U_horn_dot_below][1] = C_horn;
    _8to7map[C_U_horn_dot_below][2] = C_dot_below;
    _8to7map[C_o_hook_above][0] = C_o;
    _8to7map[C_o_hook_above][1] = C_hook_above;
    _8to7map[C_o_dot_below][0] = C_o;
    _8to7map[C_o_dot_below][1] = C_dot_below;
    _8to7map[C_o_circumflex_acute][0] = C_o;
    _8to7map[C_o_circumflex_acute][1] = C_circumflex;
    _8to7map[C_o_circumflex_acute][2] = C_acute;
    _8to7map[C_o_circumflex_grave][0] = C_o;
    _8to7map[C_o_circumflex_grave][1] = C_circumflex;
    _8to7map[C_o_circumflex_grave][2] = C_grave;
    _8to7map[C_o_circumflex_hook_above][0] = C_o;
    _8to7map[C_o_circumflex_hook_above][1] = C_circumflex;
    _8to7map[C_o_circumflex_hook_above][2] = C_hook_above;
    _8to7map[C_o_circumflex_tilde][0] = C_o;
    _8to7map[C_o_circumflex_tilde][1] = C_circumflex;
    _8to7map[C_o_circumflex_tilde][2] = C_tilde;
    _8to7map[C_o_circumflex_dot_below][0] = C_o;
    _8to7map[C_o_circumflex_dot_below][1] = C_circumflex;
    _8to7map[C_o_circumflex_dot_below][2] = C_dot_below;
    _8to7map[C_o_horn][0] = C_o;
    _8to7map[C_o_horn][1] = C_horn;
    _8to7map[C_o_horn_acute][0] = C_o;
    _8to7map[C_o_horn_acute][1] = C_horn;
    _8to7map[C_o_horn_acute][2] = C_acute;
    _8to7map[C_o_horn_grave][0] = C_o;
    _8to7map[C_o_horn_grave][1] = C_horn;
    _8to7map[C_o_horn_grave][2] = C_grave;
    _8to7map[C_U_horn_hook_above][0] = C_U;
    _8to7map[C_U_horn_hook_above][1] = C_horn;
    _8to7map[C_U_horn_hook_above][2] = C_hook_above;
    _8to7map[C_A_grave][0] = C_A;
    _8to7map[C_A_grave][1] = C_grave;
    _8to7map[C_A_acute][0] = C_A;
    _8to7map[C_A_acute][1] = C_acute;
    _8to7map[C_A_circumflex][0] = C_A;
    _8to7map[C_A_circumflex][1] = C_circumflex;
    _8to7map[C_A_tilde][0] = C_A;
    _8to7map[C_A_tilde][1] = C_tilde;
    _8to7map[C_O_horn_tilde][0] = C_O;
    _8to7map[C_O_horn_tilde][1] = C_horn;
    _8to7map[C_O_horn_tilde][2] = C_tilde;
    _8to7map[C_O_horn_dot_below][0] = C_O;
    _8to7map[C_O_horn_dot_below][1] = C_horn;
    _8to7map[C_O_horn_dot_below][2] = C_dot_below;
    _8to7map[C_U_hook_above][0] = C_U;
    _8to7map[C_U_hook_above][1] = C_hook_above;
    _8to7map[C_U_tilde][0] = C_U;
    _8to7map[C_U_tilde][1] = C_tilde;
    _8to7map[C_E_grave][0] = C_E;
    _8to7map[C_E_grave][1] = C_grave;
    _8to7map[C_E_acute][0] = C_E;
    _8to7map[C_E_acute][1] = C_acute;
    _8to7map[C_E_circumflex][0] = C_E;
    _8to7map[C_E_circumflex][1] = C_circumflex;
    _8to7map[C_U_dot_below][0] = C_U;
    _8to7map[C_U_dot_below][1] = C_dot_below;
    _8to7map[C_I_grave][0] = C_I;
    _8to7map[C_I_grave][1] = C_grave;
    _8to7map[C_I_acute][0] = C_I;
    _8to7map[C_I_acute][1] = C_acute;
    _8to7map[C_U_horn][0] = C_U;
    _8to7map[C_U_horn][1] = C_horn;
    _8to7map[C_U_horn_acute][0] = C_U;
    _8to7map[C_U_horn_acute][1] = C_horn;
    _8to7map[C_U_horn_acute][2] = C_acute;
    _8to7map[C_D_bar][0] = C_D;
    _8to7map[C_D_bar][1] = C_D;
    _8to7map[C_U_horn_grave][0] = C_U;
    _8to7map[C_U_horn_grave][1] = C_horn;
    _8to7map[C_U_horn_grave][2] = C_grave;
    _8to7map[C_O_grave][0] = C_O;
    _8to7map[C_O_grave][1] = C_grave;
    _8to7map[C_O_acute][0] = C_O;
    _8to7map[C_O_acute][1] = C_acute;
    _8to7map[C_O_circumflex][0] = C_O;
    _8to7map[C_O_circumflex][1] = C_circumflex;
    _8to7map[C_O_tilde][0] = C_O;
    _8to7map[C_O_tilde][1] = C_tilde;
    _8to7map[C_o_horn_hook_above][0] = C_o;
    _8to7map[C_o_horn_hook_above][1] = C_horn;
    _8to7map[C_o_horn_hook_above][2] = C_hook_above;
    _8to7map[C_i_tilde][0] = C_i;
    _8to7map[C_i_tilde][1] = C_tilde;
    _8to7map[C_i_dot_below][0] = C_i;
    _8to7map[C_i_dot_below][1] = C_dot_below;
    _8to7map[C_U_grave][0] = C_U;
    _8to7map[C_U_grave][1] = C_grave;
    _8to7map[C_U_acute][0] = C_U;
    _8to7map[C_U_acute][1] = C_acute;
    _8to7map[C_Y_grave][0] = C_Y;
    _8to7map[C_Y_grave][1] = C_grave;
    _8to7map[C_y_hook_above][0] = C_y;
    _8to7map[C_y_hook_above][1] = C_hook_above;
    _8to7map[C_Y_acute][0] = C_Y;
    _8to7map[C_Y_acute][1] = C_acute;
    _8to7map[C_y_tilde][0] = C_y;
    _8to7map[C_y_tilde][1] = C_tilde;
    _8to7map[C_y_dot_below][0] = C_y;
    _8to7map[C_y_dot_below][1] = C_dot_below;
    _8to7map[C_a_grave][0] = C_a;
    _8to7map[C_a_grave][1] = C_grave;
    _8to7map[C_a_acute][0] = C_a;
    _8to7map[C_a_acute][1] = C_acute;
    _8to7map[C_a_circumflex][0] = C_a;
    _8to7map[C_a_circumflex][1] = C_circumflex;
    _8to7map[C_a_tilde][0] = C_a;
    _8to7map[C_a_tilde][1] = C_tilde;
    _8to7map[C_o_horn_tilde][0] = C_o;
    _8to7map[C_o_horn_tilde][1] = C_horn;
    _8to7map[C_o_horn_tilde][2] = C_tilde;
    _8to7map[C_o_horn_dot_below][0] = C_o;
    _8to7map[C_o_horn_dot_below][1] = C_horn;
    _8to7map[C_o_horn_dot_below][2] = C_dot_below;
    _8to7map[C_u_hook_above][0] = C_u;
    _8to7map[C_u_hook_above][1] = C_hook_above;
    _8to7map[C_u_tilde][0] = C_u;
    _8to7map[C_u_tilde][1] = C_tilde;
    _8to7map[C_e_grave][0] = C_e;
    _8to7map[C_e_grave][1] = C_grave;
    _8to7map[C_e_acute][0] = C_e;
    _8to7map[C_e_acute][1] = C_acute;
    _8to7map[C_e_circumflex][0] = C_e;
    _8to7map[C_e_circumflex][1] = C_circumflex;
    _8to7map[C_u_dot_below][0] = C_u;
    _8to7map[C_u_dot_below][1] = C_dot_below;
    _8to7map[C_i_grave][0] = C_i;
    _8to7map[C_i_grave][1] = C_grave;
    _8to7map[C_i_acute][0] = C_i;
    _8to7map[C_i_acute][1] = C_acute;
    _8to7map[C_u_horn][0] = C_u;
    _8to7map[C_u_horn][1] = C_horn;
    _8to7map[C_u_horn_acute][0] = C_u;
    _8to7map[C_u_horn_acute][1] = C_horn;
    _8to7map[C_u_horn_acute][2] = C_acute;
    _8to7map[C_d_bar][0] = C_d;
    _8to7map[C_d_bar][1] = C_d;
    _8to7map[C_u_horn_grave][0] = C_u;
    _8to7map[C_u_horn_grave][1] = C_horn;
    _8to7map[C_u_horn_grave][2] = C_grave;
    _8to7map[C_o_grave][0] = C_o;
    _8to7map[C_o_grave][1] = C_grave;
    _8to7map[C_o_acute][0] = C_o;
    _8to7map[C_o_acute][1] = C_acute;
    _8to7map[C_o_circumflex][0] = C_o;
    _8to7map[C_o_circumflex][1] = C_circumflex;
    _8to7map[C_o_tilde][0] = C_o;
    _8to7map[C_o_tilde][1] = C_tilde;
    _8to7map[C_u_horn_hook_above][0] = C_u;
    _8to7map[C_u_horn_hook_above][1] = C_horn;
    _8to7map[C_u_horn_hook_above][2] = C_hook_above;
    _8to7map[C_u_horn_tilde][0] = C_u;
    _8to7map[C_u_horn_tilde][1] = C_horn;
    _8to7map[C_u_horn_tilde][2] = C_tilde;
    _8to7map[C_u_horn_dot_below][0] = C_u;
    _8to7map[C_u_horn_dot_below][1] = C_horn;
    _8to7map[C_u_horn_dot_below][2] = C_dot_below;
    _8to7map[C_u_grave][0] = C_u;
    _8to7map[C_u_grave][1] = C_grave;
    _8to7map[C_u_acute][0] = C_u;
    _8to7map[C_u_acute][1] = C_acute;
    _8to7map[C_y_grave][0] = C_y;
    _8to7map[C_y_grave][1] = C_grave;
    _8to7map[C_a_breve_hook_above][0] = C_a;
    _8to7map[C_a_breve_hook_above][1] = C_breve;
    _8to7map[C_a_breve_hook_above][2] = C_hook_above;
    _8to7map[C_y_acute][0] = C_y;
    _8to7map[C_y_acute][0] = C_y;
    _8to7map[C_y_acute][1] = C_acute;
    _8to7map[C_a_breve_tilde][0] = C_a;
    _8to7map[C_a_breve_tilde][1] = C_breve;
    _8to7map[C_a_breve_tilde][2] = C_tilde;
    _8to7map[C_a_circumflex_tilde][0] = C_a;
    _8to7map[C_a_circumflex_tilde][1] = C_circumflex;
    _8to7map[C_a_circumflex_tilde][2] = C_tilde;
}


/*
 * vk_8to7_vietnamese: Vietnamese vk_8to7().  See comments for vk_8to7().
 *		       Generates an "esc" for the following:
 *			- the esc itself
 *			- between two d's (upper- or lower-case)
 *			- between a vowel and a diacritic
 */
static int
vk_8to7_vietnamese(inbuf, outbuf, esc)
    u_char	*inbuf;
    u_char	*outbuf;
    u_char	esc;
{
    register u_char	c;
    register u_char	prevc;
    register u_char	*i, *o, *s;

    prevc = '\0';
    i = inbuf;
    o = outbuf;

    /* Try to arrange the tests from fastest to slowest */
    while (c = *i++) {
	if ( (c == esc) ||
	     (tolower(c) == 'd' && tolower(prevc) == 'd') ||
	     (ismodifier(c) && isvowel(prevc) && !ismodified(prevc)) ||
	     (isaccent(c) && isvowel(prevc) && !isaccented(prevc))) {
	    *o++ = esc;
	    *o++ = c;
	} else {
	    s = _8to7map[c];
	    while (*o = *s++) o++;
	}
	prevc = c;
    }

    *o = '\0';
    return((int) (o - outbuf));
}


/*
 * vk_8to7_english: English vk_8to7().	See comments for vk_8to7().
 *		    Generates an esc for the following:
 *			- the esc itself
 *			- an accented/modified vowel
 *			- the Vietnamese letter d-bar
 */
static int
vk_8to7_english(inbuf, outbuf, esc)
    u_char	*inbuf;
    u_char	*outbuf;
    u_char	esc;
{
    register u_char	c;
    register u_char	prevc;
    register u_char	*i, *o, *s;

    prevc = '\0';
    i = inbuf;
    o = outbuf;

    /* Try to arrange the tests from fastest to slowest */
    while (c = *i++) {
	if ( (c == esc) || isdiacriticized(c) || (tolower(c) == C_d_bar) ) {
	    *o++ = esc;
	}
	s = _8to7map[c];
	while (*o = *s++) o++;
	prevc = c;
    }

    *o = '\0';
    return((int) (o - outbuf));
}


/*
 * vk_8to7: converts the 8-bit Vietnamese "inbuf" into 7-bit
 *	    vnkeys-compliant data, and stores the result in
 *	    "outbuf".  The escape character is passed in through "esc".
 *	    The bias (Vietnamese or English) is specified with "state".
 *	    Both inbuf and outbuf must be allocated and supplied
 *	    by the caller.  Inbuf is assumed to be null-terminated.
 *
 *	    Returns the size of the actual outbuf data, in bytes,
 *	    not including the terminating NULL.
 *	    The returning outbuf is null-terminated.
 *
 *	    Note that vk_8to7() does NOT generate a leading
 *	    \V or \M in the returned outbuf.
 *
 *	    The conversion to LITERAL is NOT supported because it
 *	    won't see too much use.
 */
int  FAR PASCAL vk_8toqr(inbuf, outbuf, esc, state)
u_char FAR *inbuf; 
u_char FAR *outbuf; 
u_char esc; 
Vk_State state;
{
    static int	inited = 0;

    if (!inited) {
        _doinit();	/* private initialization function */
	inited = 1;
    }

    switch(state) {
    case VK_ST_ENGLISH:
	return vk_8to7_english(inbuf, outbuf, esc);
    case VK_ST_VIETNAMESE:
	return vk_8to7_vietnamese(inbuf, outbuf, esc);
    default:
	return 0;
    }
}




/*
 * vk_init: Initialize the state machine in the given state "st",
 *  	    using "com" as the
 * 	    compose key, and "bs" as the backspace character to be
 * 	    sent out when needed in immediate echo mode.
 *
 *	    Returns ID of FSM if successful, -1 if failed.
 */
Vk_Fsm FAR PASCAL vk_init(st, com, bs)
Vk_State st; 
u_char com; 
u_char bs;

{
    Vk_Fsm	id;

    for (id = 0; id < VK_MAX_FSMS; id++) {
    	if (!Fsm_in_use[id]) break;
    }

    if (id == VK_MAX_FSMS) return(-1);
    Fsm_in_use[id] = 1;
    State[id] = st;
    Com[id] = com;
    Bs[id] = bs;
    Batch[id] = 0; /* by default it's interactive */
    Prev_temp[id] = 0; /* in case it's initialized mid-stream */

    vncompose_init((Co_Data FAR *)&Co_data[id]); /* initialize the composition tables */

    return(id);
}


/*
 * vk_step: Takes one input key "inkey" and operates the state machine
 * 	    accordingly.  The output, if any, is stored in the user-provided
 * 	    array "outchars", with the number of characters output in
 *	    "outcount".
 *
 */
Vk_State FAR PASCAL vk_step(id, inkey, outchars, outcount)
Vk_Fsm id; 
u_char inkey; 
u_char FAR outchars[]; 
int FAR *outcount;
{
    u_char		temp;		/* for storate of composed character */
    int			fl_compose;	/* flag: in compose sequence */
    int			fl_erase;	/* flag: erase previous vowel */


    *outcount = 0;
    while (1) {

	switch(State[id]) {

/***********************************************/

	case VK_ST_LITERAL:
	    if (inkey == Com[id]) {
		State[id] = VK_ST_ESC_LITERAL;
	    } else {
		output_ch(inkey, outchars, outcount);
	    }
	    return(State[id]);

/***********************************************/

	case VK_ST_ESC_LITERAL:
	    switch(inkey) {
	    case VK_ESC_VIETNAMESE_1:
	    case VK_ESC_VIETNAMESE_2:
		State[id] = VK_ST_VIETNAMESE;
		break;
	    case VK_ESC_ENGLISH_1:
	    case VK_ESC_ENGLISH_2:
		State[id] = VK_ST_ENGLISH;
		break;
	    case VK_ESC_LITERAL_1:
	    case VK_ESC_LITERAL_2:
		State[id] = VK_ST_LITERAL;
		break;
	    default:
		State[id] = VK_ST_LITERAL;
		output_ch(Com[id], outchars, outcount);
		output_ch(inkey, outchars, outcount);
		break;
	    }
	    return(State[id]);

/***********************************************/

	case VK_ST_VIETNAMESE:
	    if (inkey == Com[id]) {
		Prev_State[id] = VK_ST_VIETNAMESE;
		State[id] = VK_ST_ESC_VIETMY;
	    } else {
		temp = vncompose(&Co_data[id], inkey, (int FAR *) &fl_compose, (int FAR *) &fl_erase);
		if (Batch[id] && fl_compose) { /* batch mode composition */
		    /* give it to EXPLICIT COMPOSITION, which delays the echo */
		    Prev_State[id] = VK_ST_VIETNAMESE;
		    State[id] = VK_ST_EXPLICIT_COMPOSE;
		    Prev_temp[id] = temp; /* save result since we're in delayed echo */
		} else { /* interactive mode composition */
		    if (fl_erase) {
			output_ch(Bs[id], outchars, outcount);
		    }
		    output_ch(temp, outchars, outcount);
		}
	    }
	    return(State[id]);

/***********************************************/

	case VK_ST_ENGLISH:
	    if (inkey == Com[id]) {
		Prev_State[id] = VK_ST_ENGLISH;
		State[id] = VK_ST_ESC_VIETMY;
	    } else {
		output_ch(inkey, outchars, outcount);
	    }
	    return(State[id]);

/***********************************************/

	case VK_ST_ESC_VIETMY:
	    switch(inkey) {
	    case VK_ESC_VIETNAMESE_1:
	    case VK_ESC_VIETNAMESE_2:
		State[id] = VK_ST_VIETNAMESE;
		return(State[id]);
	    case VK_ESC_ENGLISH_1:
	    case VK_ESC_ENGLISH_2:
		State[id] = VK_ST_ENGLISH;
		return(State[id]);
	    case VK_ESC_LITERAL_1:
	    case VK_ESC_LITERAL_2:
		State[id] = VK_ST_LITERAL;
		return(State[id]);
	    default:
		/* we got <COM>x, so flush the compose machine first */
		Prev_temp[id] = 0;
		(void) vncompose(&Co_data[id], (u_char) 0, (int FAR *) &fl_compose, (int FAR *) &fl_erase);

		if (inkey == Com[id]) {
		    output_ch(Com[id], outchars, outcount);
		    State[id] = Prev_State[id];
		    return(State[id]);
		} else {
		    State[id] = VK_ST_EXPLICIT_COMPOSE;
		    break; /* we DON'T return, go back to start composing on this key */
		}
	    }
	    break;

/***********************************************/

	case VK_ST_EXPLICIT_COMPOSE:
	    temp = vncompose(&Co_data[id], inkey, (int FAR *) &fl_compose, (int FAR *) &fl_erase);
	    if (fl_compose) { /* composition sequence starting or continuing */
		if (!fl_erase && Prev_temp[id]) {
		    /* we just ended a composition sequence, e.g., \ae */
		    output_ch(Prev_temp[id], outchars, outcount);
		    if (!Batch[id] && Prev_State[id] == VK_ST_VIETNAMESE) {
			/* we're not really in delayed echo */
			output_ch(temp, outchars, outcount);
			State[id] = VK_ST_VIETNAMESE;
		    } else {
			Prev_temp[id] = temp; /* save result since we're in delayed echo */
		    }
		} else { /* did not just end a composition sequence */
		    Prev_temp[id] = temp; /* save result since we're in delayed echo */
		}
	    } else { /* composition is finished */
		State[id] = Prev_State[id];

		/* Now, why was composition finished? */
		if (fl_erase) { /* because it's completed, e.g., \e^' */
		    output_ch(temp, outchars, outcount);
		} else if (temp == Com[id]) { /* because it's ended by \, e.g., \e^\ */
		    output_ch(Prev_temp[id], outchars, outcount);
		    State[id] = VK_ST_ESC_VIETMY;
		} else { /* because it's ended by something else, e.g., \m or \e^m */
		    if (Prev_temp[id] != 0) {
			output_ch(Prev_temp[id], outchars, outcount);
		    }
		    output_ch(temp, outchars, outcount);
		}
	    }
	    return(State[id]);
	} /* switch(St[id]) */
    } /* forever */
}


/*
 * vk_get: called when the user wishes to query the internal
 *	   state of the FSM.
 */
void FAR PASCAL vk_get(id, value, get_flag)
Vk_Fsm id; 
u_int FAR *value; 
int get_flag;
{
    if (get_flag & VK_GET_STATE) {
	*((Vk_State FAR *) value) = State[id];
    } else if (get_flag & VK_GET_ESC) {
	*((u_char FAR *) value) = Com[id];
    } else if (get_flag & VK_GET_BS) {
	*((u_char FAR *) value) = Bs[id];
    } else if (get_flag & VK_GET_BATCH) {
	*((u_char FAR *) value) = Batch[id];
    }
}


/*
 * vk_set: called when the user wishes to set the internal
 *	   state of the FSM.
 */
void FAR PASCAL vk_set(id, value, set_flag)
Vk_Fsm id; 
u_int value; 
int set_flag;
{
    if (set_flag & VK_SET_STATE) {
	State[id] = (Vk_State) value;
	vk_flush(id, 0, 0); /* flush the FSM whenever we set the state */
    } else if (set_flag & VK_SET_ESC) {
	Com[id] = (u_char) value;
    } else if (set_flag & VK_SET_BS) {
	Bs[id] = (u_char) value;
    } else if (set_flag & VK_SET_BATCH) {
	Batch[id] = (u_char) value;
    }
}


/*
 * vk_flush: flushes the characters that are still pending
 *	     in the FSM.  If "outchars" is non-zero, the pending
 *	     characters are stored there.
 */
void FAR PASCAL vk_flush(id, outchars, outcount)
Vk_Fsm id; 
u_char FAR *outchars; 
int FAR *outcount;
{
    char	dumbuf[3];
    int		dumcount;

    /* do two com's and throw away the com itself */
    if (outchars) {
	vk_step(id, Com[id], outchars, outcount);
    } else {
	vk_step(id, Com[id], (u_char FAR *)dumbuf, (int FAR *)&dumcount);
    }
    vk_step(id, Com[id], (u_char FAR *)dumbuf, (int FAR *) &dumcount);
}


/*
 * vk_end:   vk_flush() the characters that are still pending
 *	     in the FSM, and frees up the FSM for another call.
 */
void FAR PASCAL vk_end(id, outchars, outcount)
Vk_Fsm id; 
u_char FAR *outchars; 
int FAR *outcount;
{
    vk_flush(id, outchars, outcount);
    Fsm_in_use[id] = 0; /* free up the FSM */
}


/*
 * Vncompos.c is an implementation of the efficient and flexible
 * composition algorithm due to Dr. Hoc Ngo of the Viet-Std group.
 */

u_char FAR PASCAL vncompose(Co_data, inchar, fl_compose, fl_erase)
Co_Data FAR *Co_data; 
u_char inchar; 
int FAR *fl_compose; 
int FAR *fl_erase;
{
    u_char	tonemark;


    while (1) {
	switch(C_state) {

/***************************************/
	case CO_ST_LEVEL1:
	    C1 = inchar;
	    I1 = icode[C1];
	    if (I1 == 0 || I1 > 28) { /* won't compose w/ anything, e.g., "n" */
		*fl_compose = 0;	/* not composing */
	    } else { /* C1 might compose, e.g., "e" */
		*fl_compose = 1;
		C_state = CO_ST_LEVEL2;
	    }
	    *fl_erase = 0; /* no erase */
	    return(C1);


/***************************************/
	case CO_ST_LEVEL2:
	    C2 = inchar;
	    I2 = icode[C2];
	    if ((RHcode[I1] & LHcode[I2]) == 0) { /* C1 & C2 won't combine, e.g., en */
		C_state = CO_ST_LEVEL1; /* go back to level 1 and process */
		break;
	    }
	    /* C1 & C2 do combine, e.g., e^ or e' */
	    I1 = I1 + offset[I2];
	    if (LHcode[I2] & 0x38) { /* C2 is a modifier, e.g., e^ */
		C_state = CO_ST_LEVEL3;
		*fl_compose = 1;
	    } else { /* C2 is a tone mark, e.g., e' */
		*fl_compose = 0;
		C_state = CO_ST_LEVEL1;
	    }

	    tonemark = LHcode[I2] & (u_char) 0x07;
	    *fl_erase = 1;
	    return(table[I1][tonemark]);

/***************************************/
	case CO_ST_LEVEL3:
	    C_state = CO_ST_LEVEL1;
	    C3 = inchar;
	    I3 = icode[C3];
	    tonemark = LHcode[I3] & (u_char) 0x07;
	    if (tonemark == 0) { /* C3 is not a tone mark, e.g., e^n */
		break;
	    }
	    /* C3 is a tone mark, e.g., e^' */
	    *fl_compose = 0;
	    *fl_erase = 1;
	    return(table[I1][tonemark]);
	}
    } /* forever */
}


void FAR PASCAL vncompose_init(Co_data)
Co_Data FAR *Co_data;
{
    int	n;
    u_char *ptr1, *ptr2;

    C_state = CO_ST_LEVEL1;

    /*********** icode **********/
    for (n = sizeof(icode); n; n--) {
	orig_icode[n] = 0;
    }

    orig_icode[C_D]			=  1;
    orig_icode[C_A]			=  2;
    orig_icode[C_A_breve]		=  3;
    orig_icode[C_A_circumflex]	=  4;

    orig_icode[C_E]			=  6;
    orig_icode[C_I]			=  7;
    orig_icode[C_E_circumflex]	=  8;
    orig_icode[C_O]			=  9;
    orig_icode[C_U]			= 10;
    orig_icode[C_O_circumflex]	= 11;
    orig_icode[C_O_horn]		= 12;
    orig_icode[C_U_horn]		= 13;
    orig_icode[C_Y]			= 14;


    orig_icode[C_d]			= 15;
    orig_icode[C_a]			= 16;
    orig_icode[C_a_breve]		= 17;
    orig_icode[C_a_circumflex]	= 18;

    orig_icode[C_e]			= 20;
    orig_icode[C_i]			= 21;
    orig_icode[C_e_circumflex]	= 22;
    orig_icode[C_o]			= 23;
    orig_icode[C_u]			= 24;
    orig_icode[C_o_circumflex]	= 25;
    orig_icode[C_o_horn]		= 26;
    orig_icode[C_u_horn]		= 27;
    orig_icode[C_y]			= 28;

    orig_icode[CO_ACUTE]		= 29;
    orig_icode[CO_GRAVE]		= 30;
    orig_icode[CO_HOOK_ABOVE]	= 31;
    orig_icode[CO_TILDE]		= 32;
    orig_icode[CO_DOT_BELOW]		= 33;

    orig_icode[CO_BREVE]		= 34;
    orig_icode[CO_CIRCUMFLEX]	= 35;
    orig_icode[CO_HORN]		= 36;

    for (n = sizeof(icode); n; n--) {
	icode[n] = orig_icode[n];
    }

    /*********** characters used for diacritics **********/
    Co_data->acute = CO_ACUTE;
    Co_data->grave = CO_GRAVE;
    Co_data->hook_above = CO_HOOK_ABOVE;
    Co_data->tilde = CO_TILDE;
    Co_data->dot_below = CO_DOT_BELOW;
    Co_data->breve = CO_BREVE;
    Co_data->circumflex = CO_CIRCUMFLEX;
    Co_data->horn = CO_HORN;
}


/*
 * vncompose_set() allows a character to be specified for a particular
 * diacritic.  The caller must pass in the Co_data composition structure.
 * It operates by swapping the icode[] index of the characters.
 * If successful, it returns 1.  Else zero.
 *
 */

int FAR PASCAL vncompose_set(diacritic, newchar, Co_data)
int diacritic; 
u_char newchar; 
Co_Data FAR *Co_data;
{
    u_char	currentchar;
    u_char FAR	*ptr;

    switch(diacritic) {
    case CO_BREVE:
	currentchar = Co_data->breve;
	ptr = (u_char FAR *) &(Co_data->breve);
	break;
    case CO_CIRCUMFLEX:
	currentchar = Co_data->circumflex;
	ptr = (u_char FAR *) &(Co_data->circumflex);
	break;
    case CO_HORN:
	currentchar = Co_data->horn;
	ptr = (u_char FAR *) &(Co_data->horn);
	break;
    case CO_ACUTE:
	currentchar = Co_data->acute;
	ptr = (u_char FAR *) &(Co_data->acute);
	break;
    case CO_GRAVE:
	currentchar = Co_data->grave;
	ptr = (u_char FAR *) &(Co_data->grave);
	break;
    case CO_HOOK_ABOVE:
	currentchar = Co_data->hook_above;
	ptr = (u_char FAR *) &(Co_data->hook_above);
	break;
    case CO_TILDE:
	currentchar = Co_data->tilde;
	ptr = (u_char FAR *) &(Co_data->tilde);
	break;
    case CO_DOT_BELOW:
	currentchar = Co_data->dot_below;
	ptr = (u_char FAR *) &(Co_data->dot_below);
	break;
    default:
	return 0;
    }

    if (newchar != currentchar) {
        icode[newchar] = icode[currentchar];
        icode[currentchar] = orig_icode[currentchar];
        *ptr = newchar;
    }
    return(1);
} /* vncompose_set */
